/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.57 from the
 * contents of Kadm5.xs. Do not edit this file, edit Kadm5.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Kadm5.xs"
/*
 * Copyright (c) 2003, Stockholms Universitet
 * (Stockholm University, Stockholm Sweden)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the university nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <sys/un.h>
#include <krb5.h>
#include <kadm5/admin.h>
#include <kadm5/kadm5_err.h>
#include <hdb.h>
#include <kadm5/private.h>
#include <kadm5/kadm5-private.h>

#include "consts.h"

typedef struct shandle_t {
  int modcount;
  void *ptr;
  kadm5_config_params params;
  krb5_context context;
} shandle_t;

typedef struct sprincipal_t {
  shandle_t               *handle;
  int                      mask;
  kadm5_principal_ent_rec  principal;
} sprincipal_t;

static sprincipal_t *
create_sprincipal(shandle_t *handle)
{
  sprincipal_t *p = (sprincipal_t *)safemalloc(sizeof(sprincipal_t));
  
  memset(p,0,sizeof(*p));
  p->handle = handle;
  return p;
}

static void
destroy_sprincipal(sprincipal_t *spp)
{
  kadm5_free_principal_ent(spp->handle,&spp->principal);
  safefree(spp);
}

static shandle_t *
sv2server_handle(SV *sv)
{
  if (SvROK(sv) && sv_isa(sv,"Heimdal::Kadm5::SHandle"))
    return (shandle_t *)SvIV(SvRV(sv));
  else
    croak("Argument to sv2server_handle not referenced in package \"Heimdal::Kadm5::SHandle\"");
}

static sprincipal_t *
sv2sprincipal(SV *sv)
{
  if (SvROK(sv) && sv_isa(sv,"Heimdal::Kadm5::Principal"))
    return (sprincipal_t *)SvIV(SvRV(sv));
  else
    croak("Argument to sv2kadm5_principal not referenced in package \"Heimdal::Kadm5::Principal\"");
}

static int
set_param_strval(HV *hv, char **str, char *key)
{
  SV **val = hv_fetch(hv, key, strlen(key), 0);
  if (val != NULL)
    {
       *str = SvPV_nolen(*val);
       return 1;
     }
  return 0;
}

static int
set_param_intval(HV *hv, int *ival, char *key)
{
  SV **val = hv_fetch(hv, key, 0, 0);
  if (val)
    {
      *ival = (int)SvIV(*val);
      return 1;
    }
  return 0;
}

static int
not_here(s)
char *s;
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

#line 137 "Kadm5.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

/* simple backcompat versions of the TARGx() macros with no optimisation */
#ifndef TARGi
#  define TARGi(iv, do_taint) sv_setiv_mg(TARG, iv)
#  define TARGu(uv, do_taint) sv_setuv_mg(TARG, uv)
#  define TARGn(nv, do_taint) sv_setnv_mg(TARG, nv)
#endif

#line 288 "Kadm5.c"

XS_EUPXS(XS_Heimdal__Kadm5__SHandle_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, sv");
    {
	SV *	self = ST(0)
;
	SV *	sv = ST(1)
;
	shandle_t *	RETVAL;
#line 135 "Kadm5.xs"
     {
       if (SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVHV)
       {
	 HV *hv = (HV *)SvRV(sv);
	 shandle_t *handle = (shandle_t *)safemalloc(sizeof(shandle_t));
	 kadm5_ret_t ret;

	 memset(handle,0,sizeof(*handle));
	 ret = krb5_init_context(&handle->context);
	 if (ret)
	 {
	   safefree(handle);
	   croak("[Heimdal::Kadm5] krb5_init_context failed: %s\n",krb5_get_err_text(handle->context, ret));
	   handle = NULL;
	   goto cleanup;
	 }

	 if (set_param_strval(hv,&handle->params.realm,"Realm"))
	 {
           /* fprintf(stderr,"Realm=\"%s\"\n",handle->params.realm); */
	   krb5_set_default_realm(handle->context, handle->params.realm);
	   handle->params.mask |= KADM5_CONFIG_REALM;
	 }
	 /* set_param_strval(hv,&handle->params.profile,"Profile"); */
	 if (set_param_intval(hv,&handle->params.kadmind_port,"Port"))
       	    handle->params.mask |= KADM5_CONFIG_KADMIND_PORT;
	 if (set_param_strval(hv,&handle->params.admin_server,"Server"))
	    handle->params.mask |= KADM5_CONFIG_ADMIN_SERVER;

	 cleanup:
	 RETVAL = handle;
       }
       else
       {
         croak("[Heimdal::Kadm5] Argument to \"Heimdal::Kadm5::SHandle::new\" must be a hash-reference");
	 RETVAL = NULL;
       }
     }
#line 341 "Kadm5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Heimdal::Kadm5::SHandle", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__SHandle_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "handle");
    {
	shandle_t *	handle = sv2server_handle(ST(0))
;
#line 180 "Kadm5.xs"
     {
       if (handle->modcount > 0)
	 {
	   kadm5_c_flush(handle->ptr);
	 }
       if (handle->ptr)
          kadm5_c_destroy(handle->ptr);
       if (handle->context)
          krb5_free_context(handle->context);
       safefree(handle);
     }
#line 374 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_init_with_password); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_init_with_password)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "handle, client_name, password, service_name, struct_version, api_version");
    {
	shandle_t *	handle = sv2server_handle(ST(0))
;
	char *	client_name = (char *)SvPV_nolen(ST(1))
;
	char *	password = (char *)SvPV_nolen(ST(2))
;
	char *	service_name = (char *)SvPV_nolen(ST(3))
;
	unsigned long	struct_version = (unsigned long)SvUV(ST(4))
;
	unsigned long	api_version = (unsigned long)SvUV(ST(5))
;
#line 201 "Kadm5.xs"
     {
       kadm5_ret_t ret = kadm5_c_init_with_password_ctx(handle->context,
							client_name,
							password,
							KADM5_ADMIN_SERVICE, 
							&handle->params,
							struct_version, 
							api_version,
							&handle->ptr);
       if(ret)
	    croak("[Heimdal::Kadm5] kadm5_c_init_with_password_ctx failed: %s\n",
		  krb5_get_err_text(handle->context, ret));

       if (password != NULL && *password != '\0')
           ((kadm5_client_context *)handle->ptr)->prompter = NULL;
     }
#line 416 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_init_with_skey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_init_with_skey)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "handle, client_name, keytab, service_name, struct_version, api_version");
    {
	shandle_t *	handle = sv2server_handle(ST(0))
;
	char *	client_name = (char *)SvPV_nolen(ST(1))
;
	char *	keytab = (char *)SvPV_nolen(ST(2))
;
	char *	service_name = (char *)SvPV_nolen(ST(3))
;
	unsigned long	struct_version = (unsigned long)SvUV(ST(4))
;
	unsigned long	api_version = (unsigned long)SvUV(ST(5))
;
#line 227 "Kadm5.xs"
     {
       kadm5_ret_t ret = kadm5_c_init_with_skey_ctx(handle->context,
						    client_name,
						    keytab,
						    KADM5_ADMIN_SERVICE, 
						    &handle->params,
						    struct_version, 
						    api_version,
						    &handle->ptr);
       if(ret)
	    croak("[Heimdal::Kadm5] kadm5_c_init_with_skey_ctx failed: %s\n",
		  krb5_get_err_text(handle->context, ret));
     }
#line 455 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_flush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_flush)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "handle");
    {
	shandle_t *	handle = sv2server_handle(ST(0))
;
#line 245 "Kadm5.xs"
     {
       kadm5_ret_t ret = kadm5_c_flush(handle->ptr);
       if (ret)
	 croak("[Heimdal::Kadm5] kadm5_c_flush failed: %s\n",krb5_get_err_text(handle->context, ret));
       handle->modcount = 0;
     }
#line 477 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_modify_principal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_modify_principal)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "handle, spp, mask");
    {
	shandle_t *	handle = sv2server_handle(ST(0))
;
	sprincipal_t *	spp = sv2sprincipal(ST(1))
;
	int	mask = (int)SvIV(ST(2))
;
#line 258 "Kadm5.xs"
     {
       kadm5_ret_t ret;

       if (mask == 0)
	 mask = spp->mask;
       ret = kadm5_c_modify_principal(handle->ptr, &spp->principal, mask);
       if (ret)
	 {
	   if (ret)
	     croak("[Heimdal::Kadm5] kadm5_c_modify_principal failed: %s\n",
		   krb5_get_err_text(handle->context, ret));
	 }
       handle->modcount++;
     }
#line 511 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_randkey_principal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_randkey_principal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "handle, name");
    {
	shandle_t *	handle = sv2server_handle(ST(0))
;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 278 "Kadm5.xs"
     {
       krb5_keyblock *new_keys;
       int n_keys, i;
       krb5_principal principal;
       krb5_error_code err;
       kadm5_ret_t ret;

       err = krb5_parse_name(handle->context, name, &principal);
       if (err)
	 croak("[Heimdal::Kadm5] krb5_parse_name failed on \"%s\": %s\n",
	       name,krb5_get_err_text(handle->context, err));

       ret = kadm5_randkey_principal(handle->ptr, principal, &new_keys, &n_keys);
       if(ret)
	 {
	   krb5_free_principal(handle->context, principal);
	   croak("[Heimdal::Kadm5] kadm5_c_randkey_principal failed: %s\n",
		 krb5_get_err_text(handle->context, ret));
	 }
       for(i = 0; i < n_keys; i++)
	 krb5_free_keyblock_contents(handle->context, &new_keys[i]);
       free(new_keys);
       krb5_free_principal(handle->context, principal);
       handle->modcount++;
       RETVAL = n_keys;
     }
#line 557 "Kadm5.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_chpass_principal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_chpass_principal)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "handle, name, password");
    {
	shandle_t *	handle = sv2server_handle(ST(0))
;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	char *	password = (char *)SvPV_nolen(ST(2))
;
#line 313 "Kadm5.xs"
     {
       kadm5_ret_t ret;
       krb5_error_code ret2;
       krb5_principal principal;

       ret2 = krb5_parse_name(handle->context, name, &principal);
       if (ret2)
	 croak("[Heimdal::Kadm5] krb5_parse_name failed on \"%s\": %s\n",
	       name,krb5_get_err_text(handle->context, ret2));

       ret = kadm5_c_chpass_principal(handle->ptr,principal,0,0,NULL,password);
       if (ret)
	 croak("[Heimdal::Kadm5] kadm5_c_chpass_principal failed on \"%s\": %s\n",
	       name,krb5_get_err_text(handle->context, ret));
       handle->modcount++;
     }
#line 595 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_create_principal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_create_principal)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "handle, spp, password, mask");
    {
	shandle_t *	handle = sv2server_handle(ST(0))
;
	sprincipal_t *	spp = sv2sprincipal(ST(1))
;
	char *	password = (char *)SvPV_nolen(ST(2))
;
	int	mask = (int)SvIV(ST(3))
;
#line 337 "Kadm5.xs"
     {
       kadm5_ret_t ret;

       if (mask == 0)
	 mask = spp->mask;

       ret = kadm5_c_create_principal(handle->ptr,&spp->principal,mask,0,NULL,password);
       if (ret)
	 {
	   char *p;
	   krb5_error_code ret2;

	   ret2 = krb5_unparse_name(handle->context,spp->principal.principal,&p);
	   if (ret2)
	     {
	       safefree(p);
	       croak("[Heimdal::Kadm5] krb5_unparse_name failed: %s\n",
		     krb5_get_err_text(spp->handle->context, ret2));
	     }
	   croak("[Heimdal::Kadm5] krb5_c_create_principal failed on \"%s\": %s\n",
		 p,krb5_get_err_text(handle->context, ret));
	 }
       handle->modcount++;
     }
#line 641 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_rename_principal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_rename_principal)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "handle, src, trg");
    {
	shandle_t *	handle = sv2server_handle(ST(0))
;
	char *	src = (char *)SvPV_nolen(ST(1))
;
	char *	trg = (char *)SvPV_nolen(ST(2))
;
#line 368 "Kadm5.xs"
     {
       krb5_error_code ret;
       krb5_principal source, target;
       kadm5_ret_t err;

       ret = krb5_parse_name(handle->context, src, &source);
       if (ret)
	 {
	   croak("[Heimdal::Kadm5] krb5_parse_name failed on \"%s\": %s\n",
		 src,krb5_get_err_text(handle->context, ret));
	 }

       ret = krb5_parse_name(handle->context, trg, &target);
       if (ret)
	 {
	   krb5_free_principal(handle->context, target);
	   croak("[Heimdal::Kadm5] krb5_parse_name failed on \"%s\": %s\n",
		 trg,krb5_get_err_text(handle->context, ret));
	 }

       err = kadm5_c_rename_principal(handle->ptr, source, target);
       if (err)
	 {
	   krb5_free_principal(handle->context, source);
	   krb5_free_principal(handle->context, target);
	   croak("[Heimdal::Kadm5] kadm5_rename_principal \"%s\" to \"%s\" failed: %s\n",
		 src,trg,krb5_get_err_text(handle->context, err));
	 }
       krb5_free_principal(handle->context, source);
       krb5_free_principal(handle->context, target);
       handle->modcount++;
     }
#line 693 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_delete_principal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_delete_principal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "handle, name");
    {
	shandle_t *	handle = sv2server_handle(ST(0))
;
	char *	name = (char *)SvPV_nolen(ST(1))
;
#line 406 "Kadm5.xs"
     {
       krb5_error_code ret;
       krb5_principal principal;
       kadm5_ret_t err;

       ret = krb5_parse_name(handle->context, name, &principal);
       if (ret)
	 croak("[Heimdal::Kadm5] krb5_parse_name failed on \"%s\": %s\n",
	       name,krb5_get_err_text(handle->context, ret));

       err = kadm5_c_delete_principal(handle->ptr,principal);
       if (err)
	 {
	   krb5_free_principal(handle->context, principal);
	   croak("[Heimdal::Kadm5] kadm5_c_delete_principal failed for \"%s\": %s\n",
		 name,krb5_get_err_text(handle->context, err));
	 }
       handle->modcount++;
       krb5_free_principal(handle->context, principal);
     }
#line 731 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_get_principal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_get_principal)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "handle, name, mask");
    {
	shandle_t *	handle = sv2server_handle(ST(0))
;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	IV	mask = (IV)SvIV(ST(2))
;
	sprincipal_t *	RETVAL;
#line 434 "Kadm5.xs"
     {
       krb5_principal principal;
       krb5_error_code ret;
       sprincipal_t *spp;

       ret = krb5_parse_name(handle->context, name, &principal);
       if (ret)
	 croak("[Heimdal::Kadm5] krb5_parse_name failed on \"%s\": %s\n",
	       name,krb5_get_err_text(handle->context, ret));

       spp = create_sprincipal(handle);
       ret = kadm5_c_get_principal(handle->ptr,
				   principal,
				   &spp->principal,
				   mask);
       if (ret)
	 {
           if (ret == KADM5_UNK_PRINC) {
              destroy_sprincipal(spp); 
              spp = NULL;
           } else {
	      krb5_free_principal(handle->context, principal);
              destroy_sprincipal(spp); 
	      croak("[Heimdal::Kadm5] kadm5_c_get_principal failed for \"%s\": %s\n",
		    name,krb5_get_err_text(handle->context, ret));
           }
	 }
       krb5_free_principal(handle->context,principal);
       RETVAL = spp;
     }
#line 782 "Kadm5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Heimdal::Kadm5::Principal", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_get_principals); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_get_principals)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "handle, exp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	shandle_t *	handle = sv2server_handle(ST(0))
;
	char *	exp = (char *)SvPV_nolen(ST(1))
;
#line 472 "Kadm5.xs"
     {
       char **princs;
       int num_princs,i;
       kadm5_ret_t ret;

       ret = kadm5_c_get_principals(handle->ptr,exp,&princs,&num_princs);
       if (ret)
	 {
	   croak("[Heimdal::Kadm5] kadm5_c_get_principals failed for \"%s\": %s\n",
		 exp,krb5_get_err_text(handle->context, ret));
	 }
       EXTEND(SP,num_princs);
       for (i = 0; i < num_princs; i++)
	 {
	   PUSHs(sv_2mortal(newSVpv(princs[i],0)));
	 }
       kadm5_free_name_list(handle->ptr,princs,&num_princs);
     }
#line 826 "Kadm5.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_get_privs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_get_privs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "handle");
    {
	shandle_t *	handle = sv2server_handle(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 495 "Kadm5.xs"
     {
       int privs;
       kadm5_ret_t ret = kadm5_c_get_privs(handle->ptr,&privs);
       if (ret)
	 {
	   croak("[Heimdal::Kadm5] kadm5_c_get_privs failed: %s\n",
		 krb5_get_err_text(handle->context, ret));
	 }
       RETVAL = privs;
     }
#line 855 "Kadm5.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_ext_keytab); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__SHandle_c_ext_keytab)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "handle, spp, keytab");
    {
	shandle_t *	handle = sv2server_handle(ST(0))
;
	sprincipal_t *	spp = sv2sprincipal(ST(1))
;
	char *	keytab = (char *)SvPV_nolen(ST(2))
;
#line 514 "Kadm5.xs"
     {
       int i;
       krb5_keytab kt;
       krb5_error_code ret;

       if(keytab)
	 ret = krb5_kt_resolve(handle->context, keytab, &kt);
       else
	 ret = krb5_kt_default(handle->context, &kt);

       if (ret)
	 croak("[Heimdal::Kadm5] krb5_kt_resolv failed: %s\n",
	       krb5_get_err_text(handle->context, ret));

       for(i = 0; i < spp->principal.n_key_data; i++)
	 {
	   krb5_keytab_entry key;
	   krb5_key_data *k = &spp->principal.key_data[i];

	   key.principal = spp->principal.principal;
	   key.vno = k->key_data_kvno;
	   key.keyblock.keytype = k->key_data_type[0];
	   key.keyblock.keyvalue.length = k->key_data_length[0];
	   key.keyblock.keyvalue.data = k->key_data_contents[0];
	   ret = krb5_kt_add_entry(handle->context, kt, &key);
	   if (ret)
	     croak("[Heimdal::Kadm5] krb5_kt_add_entry failed: %s\n",
		   krb5_get_err_text(handle->context, ret));
	 }

       krb5_kt_close(handle->context, kt);
     }
#line 909 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, handle");
    {
	SV *	self = ST(0)
;
	shandle_t *	handle = sv2server_handle(ST(1))
;
	sprincipal_t *	RETVAL;
#line 554 "Kadm5.xs"
     {
       sprincipal_t *spp = create_sprincipal(handle);
       RETVAL = spp;
     }
#line 932 "Kadm5.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Heimdal::Kadm5::Principal", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
#line 565 "Kadm5.xs"
     {
       destroy_sprincipal(spp);
     }
#line 957 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getPrincipal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getPrincipal)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	SV *	RETVAL;
#line 573 "Kadm5.xs"
     {
       char *p;
       krb5_error_code ret;

       ret = krb5_unparse_name(spp->handle->context,spp->principal.principal,&p);
       if (ret)
	 {
	   safefree(p);
	   croak("[Heimdal::Kadm5] krb5_unparse_name failed: %s\n",
		 krb5_get_err_text(spp->handle->context, ret));
	 }
       RETVAL = newSVpv(p,0);
     }
#line 987 "Kadm5.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_setPrincipal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_setPrincipal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "spp, p");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	char *	p = (char *)SvPV_nolen(ST(1))
;
#line 594 "Kadm5.xs"
     {
       krb5_error_code ret;

       ret = krb5_parse_name(spp->handle->context,p,&spp->principal.principal);
       if (ret)
	 {
	   croak("[Heimdal::Kadm5] krb5_parse_name failed for \"%s\": %s\n",
		 p,krb5_get_err_text(spp->handle->context, ret));
	 }
       spp->mask |= KADM5_PRINCIPAL;
     }
#line 1018 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getPrincExpireTime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getPrincExpireTime)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 610 "Kadm5.xs"
     {
       XPUSHi(spp->principal.princ_expire_time);
     }
#line 1041 "Kadm5.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_setPrincExpireTime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_setPrincExpireTime)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "spp, val");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	val = (IV)SvIV(ST(1))
;
#line 619 "Kadm5.xs"
     {
       spp->principal.princ_expire_time = val;
       spp->mask |= KADM5_PRINC_EXPIRE_TIME;
     }
#line 1064 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getLastPwdChange); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getLastPwdChange)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	RETVAL;
	dXSTARG;
#line 628 "Kadm5.xs"
     {
       RETVAL = spp->principal.last_pwd_change;
     }
#line 1085 "Kadm5.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getKvno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getKvno)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	RETVAL;
	dXSTARG;
#line 638 "Kadm5.xs"
     {
       RETVAL = spp->principal.kvno;
     }
#line 1108 "Kadm5.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getMKvno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getMKvno)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	RETVAL;
	dXSTARG;
#line 648 "Kadm5.xs"
     {
       RETVAL = spp->principal.mkvno;
     }
#line 1131 "Kadm5.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getPwExpiration); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getPwExpiration)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	RETVAL;
	dXSTARG;
#line 658 "Kadm5.xs"
     {
       RETVAL = spp->principal.pw_expiration;
     }
#line 1154 "Kadm5.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_setPwExpiration); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_setPwExpiration)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "spp, val");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	val = (IV)SvIV(ST(1))
;
#line 669 "Kadm5.xs"
     {
       spp->principal.pw_expiration = val;
       spp->mask |= KADM5_PW_EXPIRATION;
     }
#line 1178 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getMaxLife); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getMaxLife)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	RETVAL;
	dXSTARG;
#line 678 "Kadm5.xs"
     {
       RETVAL = spp->principal.max_life;
     }
#line 1199 "Kadm5.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_setMaxLife); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_setMaxLife)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "spp, val");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	val = (IV)SvIV(ST(1))
;
#line 689 "Kadm5.xs"
     {
       spp->principal.max_life = val;
       spp->mask |= KADM5_MAX_LIFE;
     }
#line 1223 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getModName); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getModName)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	SV *	RETVAL;
#line 698 "Kadm5.xs"
     {
       char *p;
       krb5_error_code ret;

       if (spp->principal.mod_name) {
       ret = krb5_unparse_name(spp->handle->context,spp->principal.mod_name,&p);
       if (ret)
	 {
	   safefree(p);
	   croak("[Heimdal::Kadm5] krb5_unparse_name failed: %s\n",
		 krb5_get_err_text(spp->handle->context, ret));
	 }
     } else {
        p = NULL;
     }
       RETVAL = newSVpv(p,0);
    }
#line 1257 "Kadm5.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getModDate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getModDate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	RETVAL;
	dXSTARG;
#line 722 "Kadm5.xs"
     {
       RETVAL = spp->principal.mod_date;
     }
#line 1280 "Kadm5.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getPolicy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getPolicy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	SV *	RETVAL;
#line 732 "Kadm5.xs"
     {
       if (spp->principal.policy)
	 RETVAL = newSVpv(spp->principal.policy,0);
       else
	 RETVAL = &PL_sv_undef;
     }
#line 1305 "Kadm5.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getMaxRenewableLife); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getMaxRenewableLife)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	RETVAL;
	dXSTARG;
#line 745 "Kadm5.xs"
     {
       RETVAL = spp->principal.max_renewable_life;
     }
#line 1328 "Kadm5.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_setMaxRenewableLife); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_setMaxRenewableLife)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "spp, val");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	val = (IV)SvIV(ST(1))
;
#line 756 "Kadm5.xs"
     {
       spp->principal.max_renewable_life = val;
       spp->mask |= KADM5_MAX_RLIFE;
     }
#line 1352 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getLastSuccess); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getLastSuccess)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	RETVAL;
	dXSTARG;
#line 765 "Kadm5.xs"
     {
       RETVAL = spp->principal.last_success;
     }
#line 1373 "Kadm5.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getLastFailed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getLastFailed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	RETVAL;
	dXSTARG;
#line 775 "Kadm5.xs"
     {
       RETVAL = spp->principal.last_failed;
     }
#line 1396 "Kadm5.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getFailAuthCount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getFailAuthCount)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	RETVAL;
	dXSTARG;
#line 785 "Kadm5.xs"
     {
       RETVAL = spp->principal.fail_auth_count;
     }
#line 1419 "Kadm5.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getFailAuthCounts); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getFailAuthCounts)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	RETVAL;
	dXSTARG;
#line 795 "Kadm5.xs"
     {
       RETVAL = spp->principal.fail_auth_count;
     }
#line 1442 "Kadm5.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getAttributes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getAttributes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	RETVAL;
	dXSTARG;
#line 805 "Kadm5.xs"
     {
       RETVAL = spp->principal.attributes;
     }
#line 1465 "Kadm5.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_setAttributes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_setAttributes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "spp, val");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	IV	val = (IV)SvIV(ST(1))
;
#line 816 "Kadm5.xs"
     {
       spp->principal.attributes = val;
       spp->mask |= KADM5_ATTRIBUTES;
     }
#line 1489 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getKeytypes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getKeytypes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	SV *	RETVAL;
#line 825 "Kadm5.xs"
     {
       int i;
       AV *lst = newAV();

       for (i = 0; i < spp->principal.n_key_data; ++i) 
	 {
	   krb5_key_data *k = &spp->principal.key_data[i];
	   krb5_error_code ret;
	   char *e_string, *s_string;
	   SV *ksv[2];

	   ret = krb5_enctype_to_string (spp->handle->context,
					 k->key_data_type[0],
					 &e_string);
	   if (ret)
	     asprintf (&e_string, "unknown(%d)", k->key_data_type[0]);
	   ksv[0] = newSVpv(e_string,0);

	   ret = krb5_salttype_to_string (spp->handle->context,
					  k->key_data_type[0],
					  k->key_data_type[1],
					  &s_string);
	   if (ret)
	     asprintf (&s_string, "unknown(%d)", k->key_data_type[1]);
	   ksv[1] = newSVpv(s_string,0);

	   av_push(lst,newRV_inc((SV *)av_make(2,ksv)));
	   free (e_string);
	   free (s_string);
	 }
       RETVAL = newRV_inc((SV *)lst);
     }
#line 1538 "Kadm5.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_delKeytypes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_delKeytypes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "spp, enctype");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	char *	enctype = (char *)SvPV_nolen(ST(1))
;
#line 865 "Kadm5.xs"
     {
       krb5_key_data *new_key_data = malloc(spp->principal.n_key_data * sizeof(*new_key_data));
       krb5_enctype *etypes        = malloc(sizeof(*etypes));
       int i, j;

       krb5_string_to_enctype(spp->handle->context, enctype, etypes);

       for (i = 0, j = 0; i < spp->principal.n_key_data; ++i) {
           krb5_key_data *key = &spp->principal.key_data[i];

           if (*etypes == key->key_data_type[0]) {
               int16_t ignore = 1;
               kadm5_free_key_data (spp->handle, &ignore, key);
           } else {
               new_key_data[j++] = *key;
           }
       }

       free (spp->principal.key_data);
       spp->principal.n_key_data = j;
       spp->principal.key_data   = new_key_data;

       spp->mask |= KADM5_KEY_DATA;
       spp->handle->modcount++;

     }
#line 1584 "Kadm5.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Heimdal__Kadm5__Principal_getPassword); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5__Principal_getPassword)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "spp");
    {
	sprincipal_t *	spp = sv2sprincipal(ST(0))
;
	SV *	RETVAL;
#line 897 "Kadm5.xs"
     {
#ifdef KRB5_TL_PASSWORD
       krb5_tl_data *tl = spp->principal.tl_data;

       while (tl != NULL)
         {
	   if (tl->tl_data_type == KRB5_TL_PASSWORD)
	     break;
	   tl = tl->tl_data_next;
         }

       if (tl)
	 RETVAL = newSVpv(tl->tl_data_contents,0);
       else
#endif
	 RETVAL = &PL_sv_undef;
     }
#line 1618 "Kadm5.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Heimdal__Kadm5_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Heimdal__Kadm5_constant)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "name, arg");
    {
	char *	name = (char *)SvPV_nolen(ST(0))
;
	int	arg = (int)SvIV(ST(1))
;
	double	RETVAL;
	dXSTARG;

	RETVAL = constant(name, arg);
	TARGn((double)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Heimdal__Kadm5); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Heimdal__Kadm5)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::new", XS_Heimdal__Kadm5__SHandle_new, file, "$$");
        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::DESTROY", XS_Heimdal__Kadm5__SHandle_DESTROY, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::c_init_with_password", XS_Heimdal__Kadm5__SHandle_c_init_with_password, file, "$$$$$$");
        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::c_init_with_skey", XS_Heimdal__Kadm5__SHandle_c_init_with_skey, file, "$$$$$$");
        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::c_flush", XS_Heimdal__Kadm5__SHandle_c_flush, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::c_modify_principal", XS_Heimdal__Kadm5__SHandle_c_modify_principal, file, "$$$");
        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::c_randkey_principal", XS_Heimdal__Kadm5__SHandle_c_randkey_principal, file, "$$");
        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::c_chpass_principal", XS_Heimdal__Kadm5__SHandle_c_chpass_principal, file, "$$$");
        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::c_create_principal", XS_Heimdal__Kadm5__SHandle_c_create_principal, file, "$$$$");
        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::c_rename_principal", XS_Heimdal__Kadm5__SHandle_c_rename_principal, file, "$$$");
        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::c_delete_principal", XS_Heimdal__Kadm5__SHandle_c_delete_principal, file, "$$");
        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::c_get_principal", XS_Heimdal__Kadm5__SHandle_c_get_principal, file, "$$$");
        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::c_get_principals", XS_Heimdal__Kadm5__SHandle_c_get_principals, file, "$$");
        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::c_get_privs", XS_Heimdal__Kadm5__SHandle_c_get_privs, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::SHandle::c_ext_keytab", XS_Heimdal__Kadm5__SHandle_c_ext_keytab, file, "$$$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::new", XS_Heimdal__Kadm5__Principal_new, file, "$$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::DESTROY", XS_Heimdal__Kadm5__Principal_DESTROY, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getPrincipal", XS_Heimdal__Kadm5__Principal_getPrincipal, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::setPrincipal", XS_Heimdal__Kadm5__Principal_setPrincipal, file, "$$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getPrincExpireTime", XS_Heimdal__Kadm5__Principal_getPrincExpireTime, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::setPrincExpireTime", XS_Heimdal__Kadm5__Principal_setPrincExpireTime, file, "$$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getLastPwdChange", XS_Heimdal__Kadm5__Principal_getLastPwdChange, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getKvno", XS_Heimdal__Kadm5__Principal_getKvno, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getMKvno", XS_Heimdal__Kadm5__Principal_getMKvno, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getPwExpiration", XS_Heimdal__Kadm5__Principal_getPwExpiration, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::setPwExpiration", XS_Heimdal__Kadm5__Principal_setPwExpiration, file, "$$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getMaxLife", XS_Heimdal__Kadm5__Principal_getMaxLife, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::setMaxLife", XS_Heimdal__Kadm5__Principal_setMaxLife, file, "$$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getModName", XS_Heimdal__Kadm5__Principal_getModName, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getModDate", XS_Heimdal__Kadm5__Principal_getModDate, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getPolicy", XS_Heimdal__Kadm5__Principal_getPolicy, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getMaxRenewableLife", XS_Heimdal__Kadm5__Principal_getMaxRenewableLife, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::setMaxRenewableLife", XS_Heimdal__Kadm5__Principal_setMaxRenewableLife, file, "$$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getLastSuccess", XS_Heimdal__Kadm5__Principal_getLastSuccess, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getLastFailed", XS_Heimdal__Kadm5__Principal_getLastFailed, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getFailAuthCount", XS_Heimdal__Kadm5__Principal_getFailAuthCount, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getFailAuthCounts", XS_Heimdal__Kadm5__Principal_getFailAuthCounts, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getAttributes", XS_Heimdal__Kadm5__Principal_getAttributes, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::setAttributes", XS_Heimdal__Kadm5__Principal_setAttributes, file, "$$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getKeytypes", XS_Heimdal__Kadm5__Principal_getKeytypes, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::delKeytypes", XS_Heimdal__Kadm5__Principal_delKeytypes, file, "$$");
        (void)newXSproto_portable("Heimdal::Kadm5::Principal::getPassword", XS_Heimdal__Kadm5__Principal_getPassword, file, "$");
        (void)newXSproto_portable("Heimdal::Kadm5::constant", XS_Heimdal__Kadm5_constant, file, "$$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
